(function (d3) {
	'use strict';
  var tempCounter = 0;
  var appleRemovalRefreshCounter = 0;
  const colorScale = d3.scaleOrdinal()
    .domain(['apple', 'lemon'])
    .range(['#c11d1d', '#eae600']);

  const radiusScale = d3.scaleOrdinal()
    .domain(['apple', 'lemon'])
    .range([80, 50]);
	
	var data = [0.243, 0.584, 0.987, 0.153, 0.433];
	var extent = d3.extent(data);

	var fontScale = d3.scaleLinear()
  .domain(extent)
  .range([0, 600]);
	
  const fruitBowl = (selection, props) => {
  // tempCounter++;
  //console.log(tempCounter+" fruitBowl");
    const { fruits, height } = props;
    
    const bowl = selection.selectAll('rect')
      .data([null])
      .enter().append('rect')
        .attr('y', 110)
        .attr('width', 920)
        .attr('height', 300)
        .attr('rx', 300 / 2);
    
    const groups = selection.selectAll('g')
      .data(fruits);
    const groupsEnter = groups.enter().append('g');
    groupsEnter
      .merge(groups)
        .attr('transform', (d, i) =>
          `translate(${i * 180 + 100},${height / 2})`
        );
    groups.exit().remove();
    
    groupsEnter.append('circle')
	.attr('r', 0)
    .merge(groups.select('circle'))
      .attr('fill', d => colorScale(d.type))
    .transition().duration(1000)     
      .attr('r', d => radiusScale(d.type))
	  .transition().duration(1000)
      .attr('r', function(k){
			if(appleRemovalRefreshCounter!=3){
				return 0;
			}
		  else{
				return radiusScale(k.type);
			  }
		  });
        
    groupsEnter.append('text')
      .merge(groups.select('text'))
        .text(d => d.type)
		.style("font-size", function(k){
			return "0px";
		})
        .attr('y', 120)
		.transition().duration(1000)    
		.style("font-size", function(k){
			return "40px";//fontScale(k.type);
		})
		.transition().duration(1000)
      .style("font-size", function(k){
			if(appleRemovalRefreshCounter!=3){
				return "0px";
			}
		  else{
				return "40px";
			  }
		  });
  };

  const svg = d3.select('svg');
  let fruits;

  const render = () => {
  tempCounter++;
  console.log(tempCounter+" render");
    fruitBowl(svg, {
      fruits,
      height: +svg.attr('height')
    });
  };

  // Buy 5 apples.
  const makeFruit = type => ({ type });
  fruits = d3.range(5).map(() => makeFruit('apple'));
  render();
  
  // remove elements with some transistion
  
  
  // Eat an apple.
  setTimeout(() => {
  
	appleRemovalRefreshCounter++;
    fruits.pop();
    render();
  }, 2000);

  // Replace an apple with a lemon.
  setTimeout(() => {
	appleRemovalRefreshCounter++;
    fruits[2].type = 'lemon';
    render();
  }, 3000);

  // Eat an apple (second one from the left).
  setTimeout(() => {
	appleRemovalRefreshCounter++;
    fruits = fruits.filter((d, i) => i !== 1);
    render();
  }, 4000);

}(d3));
